#ifndef _ODM_H
#define _ODM_H
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/version.h>
#include <linux/modversions.h>
#include <linux/pci.h>
#include <linux/init.h>
#include <asm/system.h>
#include <linux/mm.h> 
#include <linux/ioport.h>
#include <asm/io.h>
#include <asm/bitops.h>
#include <asm/byteorder.h>
#include <linux/delay.h>
#include <asm/uaccess.h>
#include <linux/ioctl.h>
#include <linux/timer.h>
#include "nsmtypes.h"

typedef unsigned char UCHAR;
typedef char CHAR;
typedef unsigned short USHORT;
typedef short SHORT;
typedef unsigned int UINT;
typedef int INT;
typedef unsigned long ULONG;
typedef long LONG;
typedef void VOID;
/* typedef void * PVOID; */
typedef char bool_t;

#define	STATIC	static
#define ODMError	
#define ODMGetLoadPerPort(pAdapter)		((pAdapter)->MacStats.txOkCount)

/* MKC Revisit */
#define ODMhtons(val)	((val >>8) | (val << 8))
#define ODMGetIndex(Pkt)	(((UCHAR *)((Pkt)->pDLHeader))[5])

#define ODMDbgPrint1(arg1) printk(KERN_INFO arg1)
#define ODMDbgPrint2(arg1, arg2) printk(KERN_INFO arg1, arg2)
#define ODMDbgPrint3(arg1, arg2, arg3) printk(KERN_INFO arg1, arg2, arg3)
#define ODMDbgPrint4(arg1, arg2, arg3, arg4) printk(KERN_INFO arg1, arg2, arg3, arg4)

typedef struct _AddressStruct {
	void  *VirtAddr;
	//PHYSICAL_ADDRESS  PhysAddr;
	UCHAR *PhysAddr;
	void  *OrigSize;
	unsigned short  BufSize;
	void               *pCookie;
} AddressStruct;

/* MKC Revisit */
#define PRIV_LEVEL UCHAR	

//Added by bjaggu 

// Use 'l' as magic number 
#define LACP_MAGIC	'l'
//Added by jaggu
#define INTERFACE_SIZE	16

#define IOCTL_LACP_SHOWCONFIG	_IOR(LACP_MAGIC, 1, sizeof(PortInfo_t))   /* Revisit - size filed to filled */
#define IOCTL_LACP_CONFIG		_IOW(LACP_MAGIC, 2, sizeof(PortInfo_t))
#define IOCTL_GET_PORTS			_IOR(LACP_MAGIC, 3, sizeof(int)) 

#define DbgPrint(x) printk(x);
#define DbgPrint1(x,a) printk(x,a);
#define DbgPrint2(x,a,b) printk(x,a,b);
#define DbgPrint3(x,a,b,c) printk(x,a,b,c);

#endif

#define time_t struct timer_list *  
