#define bool_t	char
#define	LACP_FLAG	0x02
#define	GEC_FLAG	0x01
#define TRUE		1
#define	FALSE		0
#define LACP_ACTIVITY	0x01
#define MAX_PORTS	256
#define	DRIVER_PATH	"/dev/lacp0"

typedef unsigned char MacAddr[6];
typedef unsigned short USHORT;
typedef int INT;

#define LACP_MAGIC 'l'
#define IOCTL_LACP_SHOWCONFIG	_IOR(LACP_MAGIC, 1, sizeof(PortInfo_t))
#define IOCTL_LACP_CONFIG	_IOW(LACP_MAGIC, 2, sizeof(PortInfo_t))
#define IOCTL_GET_PORTS		_IOR(LACP_MAGIC, 3, sizeof(int)) 

/* Structure used by LACPCONFIG ioctl */
typedef struct _PortInfo {
    bool_t	LACP;
	bool_t	GEC;
	bool_t  LACPActivity;
	bool_t 	AggregatorPort;
	USHORT  Port;
    USHORT  Key;
	USHORT	AggregatorIdentifier;
	USHORT	ActorOperKey;
    INT     Selected;
	bool_t  LACPTimeout;
    bool_t  CollectorState;
    bool_t  DistributorState;
    bool_t  Synchronization;
	// Added by Ravi
	MacAddr	SystemId;
	USHORT	SystemPriority;
} PortInfo_t;

